<template>
  <div class="mt-box-statistique">
    <b-message type="is-danger" size="is-small" class="is-size-7" :active="dateInError">
      La date de fin est antérieure à la date de début
    </b-message>
    <section class="margin mt-fields-section columns">
      <b-field label="Début de la période" class="column is-one-third">
        <b-datepicker
          :value="start"
          placeholder="Sélectionnez une date de début"
          :first-day-of-week="1"
          :month-names="monthNames"
          :day-names="dayNames"
          :date-parser="dateParse"
          editable
          icon="calendar-today"
          class="mt-input"
          @input="dateDebutSelectionne"
        />
      </b-field>
      <b-field label="Fin de la période" class="column is-one-third">
        <b-datepicker
          :value="end"
          placeholder="Sélectionnez une date de fin"
          :first-day-of-week="1"
          :month-names="monthNames"
          :day-names="dayNames"
          :date-parser="dateParse"
          editable
          icon="calendar-today"
          class="mt-input"
          @input="dateFinSelectionne"
        />
      </b-field>
    </section>

    <section class="columns">
      <article class="column">
        <div
          v-for="(avancementActivite, index) in statistique.avancementActiviteConvoque"
          :key="index"
          class="columns marginStatististique"
        >
          <div sort-icon="chevron-up" hoverable class="column is-one-third" :style="border[index]">
            <span v-if="statistique.activitesConvoque[index] < 2" class="has-text-weight-semibold">
              {{ statistique.activitesConvoque[index] }} convocation
            </span>
            <span v-if="statistique.activitesConvoque[index] > 1" class="has-text-weight-semibold">
              {{ statistique.activitesConvoque[index] }} convocations
            </span>
            <br />
            <span
              v-if="statistique.derniereActivites[index] != null && statistique.activitesConvoque[index] > 0"
              class="font"
            >
              Dernière convocation {{ formatDate(statistique.derniereActivites[index].dateDebut) }}</span
            >
          </div>
          <div class=" column ">
            <div class="columns">
              <span class="is-bold column" :style="colors[index]">
                {{ typeActivite[index].libelle }}
              </span>
              <span>{{ statistique.avancementActiviteConvoque[index] }} %</span>
            </div>
            <progress
              max="100"
              format="percent"
              class="progress"
              :class="typeActivite[index].code"
              :value="avancementActivite"
            />
          </div>
        </div>
      </article>
      <article class="column is-one-fifth marginTop">
        <div class="  mt-box-type-statistique">
          <div class="has-text-centered font-stat-convoc-candidature ">{{ statistique.nbCandidature }}</div>
          <div class="has-text-centered">Candidatures</div>
        </div>
        <div class="  mt-box-type-statistique">
          <div class="has-text-centered font-stat-convoc-candidature convocations">{{ statistique.nbConvocation }}</div>
          <div class="has-text-centered convocations">Convocations</div>
        </div>
      </article>
    </section>

    <div v-if="!dateInError" class="columns ">
      <section class="column mt-box-type-statistique">
        <div class="columns">
          <div class="column has-text-centered font-stat">
            {{ statistique.jourDisponible }}
            <mt-disponibilite-puce is-disponible />
          </div>
          <div class="column has-text-centered font-stat">
            {{ statistique.jourIndisponible }}
            <mt-disponibilite-puce is-indisponible />
          </div>
          <div class="column has-text-centered font-stat">
            {{ statistique.jourNonRenseigne }} <span class="is-hidden-tablet">NR</span>
          </div>
        </div>
        <div class="columns is-hidden-mobile">
          <div class="column has-text-centered">Disponibilités</div>
          <div class="column has-text-centered">Indisponiblités</div>
          <div class="column has-text-centered">Non renseignés</div>
        </div>
      </section>
    </div>

    <b-table :data="statistique.avancementActivite">
      <b-tab-item field="test">
        <span> 1 </span>
      </b-tab-item>
    </b-table>
  </div>
</template>

<script>
import { DateTime } from 'luxon';
import MtDisponibilitePuce from '~/components/disponibilite/disponibilite-puce';
import DayMonthMixin from '~/components/mixins/DayMonthMixin';

export default {
  name: 'MtFicheUtilisateurStatistique',
  components: {
    MtDisponibilitePuce,
  },
  mixins: [DayMonthMixin],
  props: {
    utilisateur: {
      type: Object,
      default: () => ({}),
    },
    statistique: {
      type: Object,
      default: () => ({}),
    },
    typeActivite: {
      type: Array,
      default: () => [],
    },
    start: {
      type: Date,
      default: () => null,
      required: true,
    },
    end: {
      type: Date,
      default: () => null,
      required: true,
    },
  },
  data() {
    const tableauActivites = this.statistique.activitesConvoque;
    const labelDoughnut = [];
    const titre = '';
    return {
      labelDoughnut,
      tableauActivites,
      titre,
      border: [
        {
          borderLeft: '0.25rem solid',
          borderLeftColor: '#8c7f7f',
          borderRadius: '0.200rem',
        },
        {
          borderLeft: '0.25rem solid',
          borderLeftColor: '#973CB9',
          borderRadius: '0.200rem',
        },
        {
          borderLeft: '0.25rem solid',
          borderLeftColor: '#91c000',
          borderRadius: '0.200rem',
        },
        {
          borderLeft: '0.25rem solid',
          borderLeftColor: '#ff9a00',
          borderRadius: '0.200rem',
        },
        {
          borderLeft: '0.25rem solid',
          borderLeftColor: '#12b9f4',
          borderRadius: '0.200rem',
        },
      ],
      colors: [
        { color: '#8c7f7f' },
        { color: '#973CB9' },
        { color: '#91c000' },
        { color: '#ff9a00' },
        { color: '#12b9f4' },
      ],
    };
  },
  computed: {
    dateInError() {
      if (!this.start || !this.end) {
        return false;
      }
      return !DateTime.fromJSDate(this.start).hasSame(DateTime.fromJSDate(this.end), 'day') && this.end < this.start;
    },
  },
  watch: {
    statistique: {
      handler() {
        this.updateDonne();
      },
    },
  },
  methods: {
    formatDate(date) {
      return DateTime.fromISO(date)
        .setLocale('fr')
        .toFormat('dd/MM/yyyy');
    },

    dateDebutSelectionne(date) {
      if (date > this.end) {
        this.end = date;
      }
      this.$emit('changeDate', { dateDebut: date, dateFin: this.end });
      this.updateDonne();
    },
    dateFinSelectionne(date) {
      if (date < this.start) {
        this.start = date;
      }
      this.$emit('changeDate', { dateDebut: this.start, dateFin: date });
      this.updateDonne();
    },
    compterActivite() {
      if (this.statistique.activitesConvoques !== undefined) {
        return this.statistique.activitesConvoques.length;
      }
      return 0;
    },
    updateDonne() {
      this.remplirTableau();
      this.tableauActivites = this.statistique.activitesConvoque;
    },
    remplirTableau() {
      for (let i = 0; i < this.typeActivite.length; i += 1) {
        this.labelDoughnut[i] = this.typeActivite[i].code;
      }
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';
.progressBar {
  margin-top: 3.5rem;
  margin-bottom: 3.5rem;
}
@media (max-width: 768px) {
  .progressBar {
    margin-top: 0.5rem;
    margin-bottom: 0.5rem;
  }
}
.marginStatististique {
  margin-left: 1rem;
  margin-bottom: 1rem;
}

.is-bold {
  font-weight: bold;
}
.font {
  font-size: 0.75rem;
}
.font-stat {
  font-size: 1.5rem;
  font-weight: bold;
}

.font-stat-convoc-candidature {
  font-size: 2.25rem;
  font-weight: bold;
}
.convocations {
  color: $periwinkle;
}

.mt-box-type-statistique {
  border-radius: $border-radius;
  box-shadow: 0 2px 8px -1px rgba(102, 110, 232, 0.2);
  background-color: $white;
  margin: 0.5rem;
}
.mt-box-statistique {
  border-radius: $border-radius;
  box-shadow: 0 2px 8px -1px rgba(102, 110, 232, 0.2);
  background-color: $white;
  padding: 0.5rem;
}

// WebKit et Blink
.FOR[value]::-webkit-progress-value {
  background-color: $activity-type-formation;
}

.SOU[value]::-webkit-progress-value {
  background-color: $activity-type-soutien;
}

.DIV[value]::-webkit-progress-value {
  background-color: $activity-type-divers;
}

.PRE[value]::-webkit-progress-value {
  background-color: $activity-type-preparation;
}

.MIS[value]::-webkit-progress-value {
  background-color: $activity-type-mission;
}
// modzila et Gecko
.FOR::-moz-progress-bar {
  background-color: $activity-type-formation !important;
}
.SOU::-moz-progress-bar {
  background-color: $activity-type-soutien !important;
}
.DIV::-moz-progress-bar {
  background-color: $activity-type-divers !important;
}
.PRE::-moz-progress-bar {
  background-color: $activity-type-preparation !important;
}
.MIS::-moz-progress-bar {
  background-color: $activity-type-mission !important;
}
.plan1 {
  display: flex;
  width: 36%;
  height: 62%;
  position: absolute;
  z-index: 0;
}
@media screen and (max-width: 768px) {
  .plan1 {
    width: calc(100vw - 96px);
    height: 31.5%;
  }
}
.plan11 {
  margin: auto;
}
.plan2 {
  position: relative;
  z-index: 1;
}
.marginTop {
  margin-top: 8%;
}
</style>
